# Release Notes for NCID 1.3

## Index

* NCID Distributions
* Distribution Changes
* Server Changes
* Gateway Changes
* Client Changes
* Client Module Changes
* Tool Changes
* Documentation Changes

## NCID Distributions

> * sourceforge
> * Fedora packages
> * RPM based OS packages
> * Macintosh OS X package
> * FreeBSD package
> * Ubuntu packages
> * Debian based OS packages]

> ### sourceforge

          NCID source package:           ncid-1.3-src.tar.gz

          Cygwin 32 bit Windows package: ncid-1.3-cygwin_install.sh

          TiVo Series 2-3 package:       ncid-1.3-mips-tivo_install.sh

          Ubuntu 64 bit package:         ncid_1.3-1_amd64.deb
          Ubuntu no-arch packages:       ncid-client_1.3-1_all.deb
                                         ncid-kpopup_1.3-1_all.deb
                                         ncid-mythtv_1.3-1_all.deb
                                         ncid-samba_1.3-1_all.deb
                                         ncid-speak_1.3-1_all.deb

          Windows client installer:      ncid-1.3-client_setup.exe

> These may also be distributed:

          Fedora 64 bit package:         ncid-1.3-1.fc23.x86_64.rpm
          Fedora no-arch packages:       ncid-client-1.3-1.fc23.noarch.rpm
                                         ncid-kpopup-1.3-1.fc23.noarch.rpm
                                         ncid-mythtv-1.3-1.fc23.noarch.rpm
                                         ncid-samba-1.3-1.fc23.noarch.rpm
                                         ncid-speak-1.3-1.fc23.noarch.rpm

          Macintosh 64 bit OS X package: ncid-1.3-mac-osx_install.sh
          (Universal binary, OSX 10.4+)

          FreeBSD 32 bit package:        ncid-1.3-FreeBSD-10.2_install.sh

          Debian packages:               Ubuntu packages should install as-is

          Raspberry Pi packages:         ncid_1.3-1_armhf.deb
                                         other packages are the same as Ubuntu

> ### Fedora packages

> Available at the Fedora repository (sometimes sourceforge).
  New release first appears in the rawhide repository.
  There are server, client, and optional output module packages.
  Normally you only need to install the **ncid** and **ncid-client** rpm packages.

> The dnf list command will show you the packages available:

          dnf list ncid\*

> If the above does not show version 1.1:

          dnf --enablerepo=rawhide list ncid\*

> If the rawhide repo is not installed:

          dnf install fedora-release-rawhide

> If you need to build packages for your specific OS release:

          rpmbuild -tb ncid-1.3-src.tar.gz

> ### RPM based OS packages

> Includes Fedora, Redhat, CentOS, etc.

> If a dependency can not be resolved, you should try rebuilding packages:

          - Download the latest NCID deb packages from sourceforge:
            ncid RPM Package
            ncid-client RPM Package - client and default output modules
          - Download any optional output modules wanted:
            ncid-MODULE RPM Package  - optional client output modules
          - Install or Upgrade the packages using dnf
                * Install the NCID server and gateways:
                  sudo dnf install ncid-<version>.fc23.x86_64.rpm
                * Install the client package and default modules:
                  sudo dnf install ncid-client-<version>.fc23.x86_64.rpm
                * Install any optional modules wanted:
                  sudo gdebi ncid-<module-<version>.fc23.x86_64.rpm

          Notes:
              <version> would be something like: 1.3-1
              <module> would be a module name like: kpopup, mythtv, samba

> ### Macintosh OS X package

          Available at MacPorts (sometimes sourceforge).
              http://trac.macports.org/browser/trunk/dports/net/ncid/Portfile

> ### FreeBSD package

          Available at FreshPorts (sometimes sourceforge).
              http://www.freshports.org/comms/ncid/

> ### Ubuntu packages

> Available at the 3rd Party Repository: GetDeb Apps (sometimes sourceforge).

> Add the repository if needed:

          wget -q -O - http://archive.getdeb.net/getdeb-archive.key \
              | sudo apt-key add -
          sudo sh -c \
              "echo 'deb http://archive.getdeb.net/ubuntu precise-getdeb apps' \
              >> /etc/apt/sources.list"
          Update the apt cache:
              sudo apt-get update
          List the available packages:
              sudo apt-cache search ncid
          Install the server and client:
              sudo apt-get install ncid ncid-client
          Install any optional output modules wanted:
              sudo apt-get install ncid-<module>

> ### Debian based OS packages

> Includes Debian, Ubuntu, Raspbian, etc.

> If the latest package is not available at the repository:

        - Download the latest NCID deb packages from sourceforge:
          ncid DEB Package
          ncid-client DEB Package - client and default output modules

        - Download any optional output modules wanted:
          ncid-MODULE DEB Package  - optional client output modules

        - Install or Upgrade the packages using the gdebi-gtk (GUI):
            * If needed use the the menu item "Add/Remove.." to install the
              GDebi Package Installer.
            * Using the file viewer:
                - Open the file viewer to view the NCID DEB packages
                - Select the DEB packages
                - double-click selections or right-click selections and select
                  "Open with GDebi Package installer"

        - Install or Upgrade the packages using gdebi (command line):
            * Install gdebi if needed:
              sudo apt-get install gdebi    
            * Install the NCID server and gateways:
              sudo gdebi ncid-<version>_<processor>.deb
            * Install the client package and default modules:
              sudo gdebi ncid-client-<version>_all.deb
            * Install any optional modules wanted:
              sudo gdebi ncid-<module-<version>_all.deb

        Notes:
            <version> would be something like: 1.3-1
            <processor> would be something like: i386, armhf
            <module> would be a module name like: kpopup, mythtv, samba

> If you need to build a package for your specific OS or release, the
  build-essential, fakeroot, and libpcap packages must be installed:

            sudo apt-get build-essential fakeroot libpcap0.8-dev
            tar -xzf ncid-1.3-src.tar.gz
            mv ncid ncid-1.3
            cd ncid-1.3
            fakeroot debian/rules build
            fakeroot debian/rules binary
            fakeroot debian/rules clean

## Distribution Changes

> Cygwin:

> - Binary package uses an install script instead of a tar archive

> Fedora, Redhat, and RPM based systems:

> FreeBSD:

> - Binary package uses an install script instead of a tar archive

> Mac OS X:

> - Binary package uses an install script instead of a tar archive

> Ubuntu, Raspbian, Debian based systems:

> TiVo:

> - Binary package uses an install script instead of a tar archive

> Windows:

## Server Changes

> ncidd:

> - Added a **match name** field that replaces a line comment in ncidd.blacklist and
    ncidd.whitelist.  The blacklist name replaces an alias or caller ID name on hangup.
    The whitelist name replaces an alias or caller ID name when it is found in the whitelist.
    see [Using Hangup](http://ncid.sourceforge.net/doc/NCID-UserManual.html#hangup_top)

> - Added regular expressions to aliases.  Regular expressions already used in the blacklist
    and whitelist.  The **regex** option in ncidd.conf turns on regular expressions.  They
    are off by default.

> ncidd.conf:

> - updated hangup comments
  - added CallingDeposit.rmd, CannotBeCompleted.rmd, NotInService.rmd
    as additional announce recording files


## Gateway Changes

> ncid2ncid:

> obi2ncid:

> rn2ncid:

> sip2ncid:

> wc2ncid:

> yac2ncid:



## Client Changes

> ncid:

> - removed ignore1 code

> - changes some variable names to reflect how they are used
## Client Module Changes

> all modules:

> ncid-page:

## Tool Changes

> cidalias:

> - fixed problems, updated documentation

> cidcall:

> - Fixed problems, updated documentation

> cidupdate:

> - fixed problems, updated documentation

> ncidutil:

> - fixed problems, updated documentation


## Documentation Changes

> - ported **NCID-API**.odt version 1.2 to **NCID-API**.md

> - updated **NCID-API** to version 1.2

> - renamed NCID_Documentation to NCID-UserManual.md

> - updated alias and hangup sections in **NCID-UserManual.md**

